<?php 
final class Router {

	private $dir_pages;
	
	private $config;
	
	function __construct() {
		$this->config = get_config('routes');
		
		$this->dir_pages = ROOT_DIR . $this->config['dir_pages'];
		
		$uri = Main::lib('URI');
		
		$uri_string = $uri->getUriString();
		
		if (!$uri_string) {
			if(isset($this->config['default_page'])) {
				$uri_string = $this->config['default_page'];
			} else {
				$uri_string = '404';
			}
		} else {
			if (preg_match('#[^\w/]+#', $uri_string)) {
				$uri_string = '404';
			}
		}
		
		if (!file_exists($this->dir_pages . '/' . $uri_string)) {
			$uri_string = '404';
		}
		
		//    ,  
		$vars = include($this->dir_pages . '/' . $uri_string . '/' . $uri_string . '_vars.php');
		
		echo Main::lib('View')->generate($vars['template'], $vars);
	}
	
}