var sortTable = (function (GLOB) {
    var DOC = GLOB.document;
    return function (elementTable, elementAsc, elementDesc, onSortAsc, onSortDesc) {
		if (!elementTable || !elementAsc || !elementDesc) {
                throw new Error ("sortTabe ERROR: Parameters 1,2,3 - is required!");                
        }
        var cellsCnt    = elementTable.rows[0].cells.length,
            rows        = elementTable.tBodies[0].rows,
			sortState   = {dir:"none", idx: null},
            hcell,
            sorter,
            i, j;			
        // Получить элемент управления сортировкой
        function getSorter(idx, table, type) {			
            var sorterAsc   = DOC.createElement("SPAN"),
                sorterDesc  = DOC.createElement("SPAN");
            sorterAsc.appendChild(elementAsc.cloneNode(true));
            sorterDesc.appendChild(elementDesc.cloneNode(true));			
            // Функция кроссбраузерно меняет местами узлы DOM
            function swapNode(node1, node2) {
                var next        = node1.nextSibling,
                    parentNode  = node1.parentNode;
					
                if (node1.swapNode) {
                    return node1.swapNode(node2);
                }
				
                node2.parentNode.replaceChild(node1, node2);
                parentNode.insertBefore(node2, next);
            }
            // Сортировка в прямом порядке
            sorterAsc.onclick   = function () {
				// Проверка состояния
				if (sortState.dir === "asc" && sortState.idx === idx) {
					return false;	
				}				
				// ************ Пузырьковая сортировка ************
                for (i = 0; i < rows.length - 1; i += 1) {
                    for (j = i + 1; j < rows.length; j += 1) {
                        if (rows[i].cells[idx].innerHTML > rows[j].cells[idx].innerHTML) {
                            swapNode(rows[i], rows[j]);
                        }
                    }
                }
				// ************ Пузырьковая сортировка конец ******				
				// Установка состояния
				sortState.dir = "asc"; 
				sortState.idx = idx;     				
				if (onSortAsc) {
					onSortAsc(sortState);
				} 
            };
            // Сортировка в обратном порядке
            sorterDesc.onclick  = function () {
				// Проверка состояния
				if (sortState.dir === "desc" && sortState.idx === idx) {
					return false;	
				}				
				// ************ Пузырьковая сортировка ************
                for (i = 0; i < rows.length - 1; i += 1) {
                    for (j = i + 1; j < rows.length; j += 1) {
                        if (rows[i].cells[idx].innerHTML < rows[j].cells[idx].innerHTML) {
                            swapNode(rows[i], rows[j]);
                        }
                    }
                }
				// ************ Пузырьковая сортировка конец ******				
				// Установка состояния
				sortState.dir = "desc"; 
				sortState.idx = idx;				
                if (onSortDesc) {
					onSortDesc(sortState);
				} 
            };
            return {asc : sorterAsc, desc : sorterDesc};
        }
		// Пройдёмся по всем ячейкам первой строки и вставим в них значки-сортировщика:
        for (i = 0; i < cellsCnt; i += 1) {
            sorter = getSorter(i, elementTable);
            hcell  = elementTable.rows[0].cells[i];
			
            hcell.appendChild(sorter.asc);
            hcell.appendChild(sorter.desc);
        }
        return;
    };
}(this));
